/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gpl.fredy.sqltools;

/**
 * This class represents a Tablefield and is used by the XML-Importer
 * to create the table
 *
 *
 *
 * Admin is a Tool around JDBC-enabled SQL-Databases to do basic jobs
 * for DB-Administrations, as create / delete / alter and query tables
 * it also creates indices and generates simple Java-Code to access DBMS-tables
 * and exports data into various formats
 *
 *
 *   Copyright (C)     2010, Fredy Fischer
 *                           sql@hulmen.ch
 *   Postal: Fredy Fischer
 *           Hulmenweg 36
 *           8405 Winterthur
 *           Switzerland
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
/**
 *
 * @author afs
 */
public class TableField {

    private String fieldName = null;
    private String fieldType = null;
    private String length = null;
    private String xmlField = null;   
    private String[] options;
    private int insertSequence = 0;


    /**
     * @return the fieldName
     */
    public String getFieldName() {
        return fieldName;
    }

    /**
     * @param fieldName the fieldName to set
     */
    public void setFieldName(String fieldName) {
        this.fieldName = fieldName;
    }

    /**
     * @return the fieldType
     */
    public String getFieldType() {
        return fieldType;
    }

    /**
     * @param fieldType the fieldType to set
     */
    public void setFieldType(String fieldType) {
        this.fieldType = fieldType;
    }

    /**
     * @return the length
     */
    public String getLength() {
        return length;
    }

    /**
     * @param length the length to set
     */
    public void setLength(String length) {
        this.length = length;
    }

    /**
     * @return the options
     */
    public String[] getOptions() {
        return options;
    }

    /**
     * @param options the options to set
     */
    public void setOptions(String[] options) {
        this.options = options;
    }

    public void addOption(String v) {
        int n = options.length + 1;
        options[n] = v;
    }

    public int optionsLength() {
        try {
            return options.length;
        } catch (Exception e) {
            return 0;
        }
    }

    public String getOption(int n) {
        return options[n];
    }

    /**
     * @return the xmlField
     */
    public String getXmlField() {
        return xmlField;
    }

    /**
     * @param xmlField the xmlField to set
     */
    public void setXmlField(String xmlField) {
        this.xmlField = xmlField;
    }

    /**
     * @return the insertSequence
     */
    public int getInsertSequence() {
        return insertSequence;
    }

    /**
     * @param insertSequence the insertSequence to set
     */
    public void setInsertSequence(int insertSquence) {
        this.insertSequence = insertSquence;
    }

 }
