/*
 * GraphicTest.java
 *
 * Created on December 14, 2004, 4:41 PM
 *
 * This software is part of the Admin-Framework and under LGPL
 *
 * Admin is a Tool around JDBC-enabled SQL-Databases to do basic jobs
 * for DB-Administrations, as create / delete / alter and query tables
 * it also creates indices and generates simple Java-Code to access DBMS-tables
 *
 *
 *   Copyright (C) December 14, 2004, Fredy Fischer
 *                           sql@hulmen.ch
 *   Postal: Fredy Fischer
 *           Hulmenweg 36
 *           8405 Winterthur
 *           Switzerland
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package gpl.fredy.test;

import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;




/**
 *
 * @author  afs
 */
public class GraphicTest  extends JPanel {
    
    final static Color bg = Color.yellow;
    final static Color fg = Color.black;
    final static Color red = Color.red;
    final static Color white = Color.white;
    
    final static BasicStroke stroke = new BasicStroke(2.0f);
    final static BasicStroke wideStroke = new BasicStroke(8.0f);
    
    
    /** Creates a new instance of GraphicTest */
    public GraphicTest() {
        
        this.setBackground(bg);
        this.setForeground(fg);
     
    }
    public void paint(Graphics g) {        
        //Graphics2D g2 = (Graphics2D) panel.getGraphics();
        Graphics2D g2 = (Graphics2D) g;
        g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        Dimension d = this.getSize();
        int gridWidth = d.width / 6;
        int gridHeight = d.height / 2;

        Color fg3D = Color.lightGray;

        g2.setPaint(fg3D);
        g2.draw3DRect(0, 0, d.width - 1, d.height - 1, true);
        g2.draw3DRect(3, 3, d.width - 7, d.height - 7, false);
        g2.setPaint(fg);
        
        
        int x = 10;
        int y = 10;
        int rectWidth  = d.width -  2*x;
        int rectHeight = d.height - 2*y;
	
        fg3D = Color.blue;
        g2.setPaint(fg3D);
	g2.setStroke(stroke);
       
        g2.draw(new Rectangle2D.Double(x, y, rectWidth, rectHeight));
        
        
    }
    
    public static void main(java.lang.String[] args) {
        GraphicTest gt = new GraphicTest();
        JFrame frame = new JFrame("Mein Grafiktest");
        frame.getContentPane().setLayout(new BorderLayout());
        frame.getContentPane().add(BorderLayout.CENTER,gt);
        frame.pack();
        frame.setVisible(true);
    }    
    
    
}
