package gpl.fredy.webmail;

import java.util.Vector;
import java.util.StringTokenizer;
import java.util.Date;
import javax.mail.*;
import javax.mail.internet.*;
import java.util.logging.*;

public class MessageHeader {
    
    Vector from, recpt, rply, cc;
    Date   rcvDate;
    
    private Logger logger = Logger.getLogger("gpl.fredy.webmail");
    Message message;
    public void setMessage(Message m) throws Exception {
        message = m;
        
        from = new Vector();
        recpt= new Vector();
        rply = new Vector();
        cc   = new Vector();
        rcvDate = toDay();
        
        int i=0;
        try {
            for (i=0; i < message.getFrom().length; i++ ) {
                InternetAddress frm = new InternetAddress(message.getFrom()[i].toString());
                from.addElement((String) frm.getAddress());
            }
        } catch (Exception ee1) { }
        
        try {
            for (i=0; i < message.getRecipients(Message.RecipientType.TO).length; i++ ) {
                InternetAddress rcv = new InternetAddress(message.getRecipients(Message.RecipientType.TO)[i].toString());
                recpt.addElement((String)rcv.getAddress());
            }
        } catch (Exception ee2) { }
        
        try {
            for (i=0; i < message.getRecipients(Message.RecipientType.CC).length; i++ ) {
                InternetAddress rcv = new InternetAddress(message.getRecipients(Message.RecipientType.CC)[i].toString());
                cc.addElement((String)rcv.getAddress());
            }
        } catch (Exception ee3) { }
        
        try {
            for (i=0; i < message.getReplyTo().length;i++ ) {
                InternetAddress rpl = new InternetAddress(message.getReplyTo()[i].toString());
                rply.addElement((String) rpl.getAddress() );
            }
        } catch (Exception ee4) { }
        
        setSubject(message.getSubject() );
        rcvDate = message.getReceivedDate();
        if ( rcvDate == null ) rcvDate = toDay();
        
        
        MimeMessage mm = (MimeMessage)message;
        StringTokenizer st = new StringTokenizer(mm.getContentType(),";");
        setMessageType(st.nextToken());
        
        setMessageNumber(message.getMessageNumber());
        
        setFlags(message.getFlags());
        
    }
    
    private Date toDay() {
        java.util.Calendar cal = java.util.Calendar.getInstance();
        return cal.getTime();
        
    }
    
    int messageNumber=0;
    public void setMessageNumber(int v) { this.messageNumber = v; }
    public int  getMessageNumber() { return this.messageNumber; }
    
    String subject;
    public void setSubject(String v) { this.subject = v; }
    public String getSubject() { return this.subject; }
    
    String messageType;
    public void setMessageType(String v) { this.messageType = v; }
    public String getMessageType() { return this.messageType; }
    
    public Vector getFrom() { return from; }
    public Vector getRecipients() { return recpt; }
    public Vector getCC() { return cc; }
    public Vector getReply() { return rply; }
    public Date   getRcvDate() { return rcvDate; }
    
    Flags flags;
    
    /**
     * Get the value of flags.
     * @return value of flags.
     */
    public Flags getFlags() {
        Flags flags = null;
        try {
            flags = message.getFlags();
        } catch (javax.mail.MessagingException gopf) {
            flags= null;
        }
        return flags;
    }
    
    /**
     * Set the value of flags.
     * @param v  Value to assign to flags.
     */
    public void setFlags(Flags  v) {
        this.flags = v;
    }
    
    public void setSeen() {
        try {
            message.setFlag(Flags.Flag.SEEN,true);
            message.saveChanges();
        } catch (IllegalWriteException iex) {
            logger.log(Level.WARNING,"Can not write: " + iex.getMessage());
        } catch (MessagingException mex) {
            logger.log(Level.WARNING,"Can not set SEEN Flag");
        } catch (Exception e) {
            logger.log(Level.WARNING,"Exception while setting SEEN-Flag: " + e.getMessage());
        }
    }
    
    public String getMyFlag() {
        String s = "N";
        Flags.Flag[] sf = getFlags().getSystemFlags();
        for (int i = 0; i < sf.length; i++) {
            if (sf[i] == Flags.Flag.ANSWERED)   s = "A";
            if (sf[i] == Flags.Flag.RECENT)     s = "N";
            if (sf[i] == Flags.Flag.SEEN)       s = "S";
            if (sf[i] == Flags.Flag.DELETED)    s = "D";
        }
        return s;
    }
    
    public void delete() {
        try {
            message.setFlags(new Flags(Flags.Flag.DELETED), true);
        } catch ( javax.mail.MessagingException mex) {
        }
        
    }
    
    public MessageHeader() {
        
    }
    public MessageHeader(Message m) {
        try {
            this.setMessage(m);
        } catch (Exception e) { e.printStackTrace(); }
    }
}

